import { useCallback as s, useState as f } from "react";
import { useEventListener as h } from "./useEventListener.js";
const u = "av-local-storage", E = (t) => {
  try {
    return JSON.stringify(t);
  } catch {
    throw new Error(
      "@versini/ui-hooks useLocalStorage: Failed to serialize the value"
    );
  }
}, m = (t) => {
  try {
    return t && JSON.parse(t);
  } catch {
    return t;
  }
};
function N({
  key: t,
  defaultValue: l,
  deserialize: w = m,
  serialize: n = (e) => E(e)
}) {
  const e = typeof l == "function" ? l() : l, a = s(() => {
    let o;
    try {
      o = typeof window > "u" || !("localStorage" in window) || window.localStorage === null;
    } catch {
      o = !0;
    }
    if (o)
      return window.localStorage.setItem(t, n(e)), e;
    try {
      const r = window.localStorage.getItem(t);
      return r !== null ? w(r) : (window.localStorage.setItem(t, n(e)), e);
    } catch (r) {
      return console.warn(`Error reading localStorage key “${t}”:`, r), e;
    }
  }, [e, w, t, n]), [c, i] = f(a()), g = s(
    (o) => {
      try {
        const r = o instanceof Function ? o(c) : o;
        if (r === void 0)
          return;
        window.localStorage.setItem(t, n(r)), i(r), window.dispatchEvent(new Event(u));
      } catch (r) {
        console.warn(`Error setting localStorage key “${t}”:`, r);
      }
    },
    [t, n, c]
  ), S = s(() => (window.localStorage.removeItem(t), i(a()), window.dispatchEvent(new Event(u)), c), [t, a, c]), d = s(
    (o) => {
      o != null && o.key && o.key !== t || i(a());
    },
    [t, a]
  );
  return h(u, d), [c, g, S];
}
export {
  N as useLocalStorage
};
